<template>
  <dibs-layout page="prelogin" layout="two-columns" :video="video">
    <template #aside-header>
      <dibs-elem-back to="/prelogin" />
      <dibs-elem-lang-dropdown />
    </template>
    <template #aside-title
      ><h1>M'authentifer via ma caisse de pension</h1></template
    >
    <template #content>
      <h2>Connectez vous au service grâce à votre Caisse de pension</h2>
      <dibs-form-elem
        v-if="funds"
        hint="<ul>
        <li>
          Star Fund :
          <ul>
            <li><pre>alice/alice</pre></li>
            <li><pre>beatrice/beatrice</pre></li>
            <li><pre><a href='https://iam.openpk.acrea.com/auth/realms/pensionfund/protocol/openid-connect/logout' target='_blank'>Star Fund Logout</a></pre></li>
          </ul>
        </li>
      </li>
    </ul>"
        :label="$t('page.lpp.form.label')"
        name="lpp"
      >
        <dibs-form-row :element-count="1" :has-ending="true">
          <dibs-input-select-search
            id="lpp"
            v-model="lpp"
            :default="lpp"
            :options="Object.values(funds)"
            label="name"
          />
        </dibs-form-row>
      </dibs-form-elem>

      <dibs-elem-btn
        :disabled="!formIsOk"
        label="Me connecter via ma caisse de pension"
        picto="forward"
        @click="onLogin"
      />
      <dibs-modal id="cgv">
        <template #title>{{ $t("page.prelogin.cgv.title") }}</template>
        <template #content>
          <!-- eslint-disable-next-line vue/no-v-html -->
          <div v-html="$t('page.prelogin.cgv.html')" />
        </template>
      </dibs-modal>
    </template>
  </dibs-layout>
</template>

<script>
definePageMeta({
  middleware: ["if-authenticated-then-router"],
});

export default {
  name: "IndexPage",
  layout: "dibs",
  data() {
    return {
      accepted: false,
      video: this.$tm("page.prelogin.video"),
      funds: null,
      grantingWindow: null,
      lpp: null,
    };
  },
  computed: {
    formIsOk() {
      return !!this.lpp;
    },
  },
  mounted() {
    this.init();
  },
  methods: {
    init() {
      this.$models.Loader().on();

      window.addEventListener(
        "message",
        (msg) => {
          if (!this.grantingWindow) {
            return;
          }
          const data = msg.data;
          if (data === "grant-is-okay") {
            this.$models.Loader().on();
            msg.source.close();
            this.grantingWindow = null;
            this.grantingOk = true;

            this.$router.push(this.localePath("/synthesis"));
          }
        },
        false,
      );

      this.$models
        .OpenPK()
        .getLoginRegistry()
        .then((funds) => {
          this.funds = funds;
        })
        .catch(() => {})
        .finally(() => {
          this.$models.Loader().off();
        });
    },
    onLogin() {
      if (!this.formIsOk) {
        return;
      }
      this.$models.Loader().on();
      this.grantingOk = false;

      this.startGranting(this.lpp.id);
    },
    startGranting(pensionFundId) {
      window.open(
        this.$config.public.dibsApiBasePath +
          "/login/pension-funds/connect?pension-fund-id=" +
          pensionFundId,
        "_blank",
      );
      this.grantingWindow = true;
      this.$models.Loader().off();
    },
  },
};
</script>
